uniform vec2 iResolution;
uniform float iGlobalTime;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;

#define PI 3.14159265

float rand(vec2 co){
    return fract(sin(dot(co, vec2(12.9898, 78.233))) * 43758.5453);
}

void main()
{
    float horizon = sin(iGlobalTime)*0.02;
    float fov = 1.0;

    float pixY = (gl_FragCoord.y/iResolution.y);
    vec2 sc_uv = gl_FragCoord.xy / iResolution.yy - vec2((iResolution.x/iResolution.y)*0.5, 0.5);

    vec2 uv = vec2(sc_uv.x/(sc_uv.y-horizon), (sc_uv.y-horizon-fov)/(sc_uv.y-horizon));
    uv.y=abs(uv.y);

    uv.x -= iGlobalTime;
    uv *= 0.1;

    gl_FragColor = texture2D(iChannel0, uv);

    gl_FragColor.rgb -= sin(sc_uv.x*10.0+iGlobalTime)*sin(sc_uv.y*10.0+iGlobalTime)*0.3+0.4;

    vec2 uv_s = gl_FragCoord.xy/iResolution.yy;
    float mov = iGlobalTime*0.36/6.0;
    uv_s.x *= 32.0/2048.0;
    uv_s *= 6.0;
    uv_s.x += mov+rand(uv_s.yy+iGlobalTime)*0.0005;
    vec4 col = texture2D(iChannel1, uv_s);
    if (gl_FragCoord.y > (iResolution.y/6.0) && gl_FragCoord.y <(iResolution.y/6.0)*2.0)
        gl_FragColor.rgb = (col.rgb*col.a)+(gl_FragColor.rgb*(1.0-col.a));

    gl_FragColor.a = 0.1;
    gl_FragColor.rgb *= mod(gl_FragCoord.y, 2.0);

    gl_FragColor.rgb *= clamp(iGlobalTime, 0.0, 1.0);
    gl_FragColor.rgb *= clamp(16.0-iGlobalTime, 0.0, 1.0);
}
