uniform vec2 iResolution;
uniform float iGlobalTime;
uniform sampler2D iChannel0;

float rand(vec2 co){
    return fract(sin(dot(co, vec2(12.9898, 78.233))) * 43758.5453);
}

void main() {
    gl_FragColor=vec4(vec3(0.0), 0.2);
    vec2 uv = gl_FragCoord.xy/iResolution.yy;
    
    float ofs = (((iResolution.y/2.0)/2.0)/iResolution.y);
    float scn_ofs = (iResolution.x-iResolution.y)/2.0;
    float ofs_p = iResolution.y*ofs;
    
    uv -= vec2(ofs); 
    uv.x -= scn_ofs/iResolution.y;
    uv *= 2.0;
    uv.x += rand(uv.yy+iGlobalTime)*0.007*iGlobalTime;
    
    float timer = clamp((3.0-iGlobalTime/2.0), 0.0, 1.0);
    
    vec4 lColor = texture2D(iChannel0, uv);
    if (gl_FragCoord.x > ofs_p+scn_ofs && gl_FragCoord.x < ofs_p*2.0*2.0-(ofs_p)+scn_ofs && gl_FragCoord.y > ofs_p && gl_FragCoord.y < ofs_p*2.0*2.0-(ofs_p))
        gl_FragColor.rgb = (lColor.rgb*lColor.a*timer) + (gl_FragColor.rgb*(1.0-lColor.a*timer));
    gl_FragColor.rgb *= mod(gl_FragCoord.y, 2.0);
}
