uniform vec2 iResolution;
uniform float iGlobalTime;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;

#define LOGO_H 10.0

float rand(vec2 co){
    return fract(sin(dot(co, vec2(12.9898, 78.233))) * 43758.5453);
}

vec3 blend(vec4 i) {
    return i.rgb*i.a+(gl_FragColor.rgb*(1.0-i.a));
}

void main() {
    vec2 uv = gl_FragCoord.xy / iResolution.xy;
    
    vec2 uv_p = vec2(uv.x * sin(iGlobalTime*0.5) - uv.y * cos(iGlobalTime*0.5), uv.x * cos(iGlobalTime*0.5) + uv.y * sin(iGlobalTime*0.5));
    uv_p *= 3.0;
    uv_p.x += sin(uv_p.y+iGlobalTime)*0.4;
    uv_p.y += sin(uv_p.x*2.0+iGlobalTime)*0.5;
    uv_p *= vec2(sin(uv_p.x*4.0+iGlobalTime)*0.4+0.4, cos(uv_p.y*13.0+iGlobalTime)*0.4+0.4);
    vec3 col1 = vec3(0.0, 0.3, 0.4);
    vec3 col2 = vec3(0.0, 0.4, 0.2);
    float a1 = sin(uv_p.x*(sin(iGlobalTime)*20.0+10.0))*0.5 + 0.5;
    float a2 = sin(uv_p.y*(sin(iGlobalTime)*17.0+8.0))*0.5 + 0.5;

    gl_FragColor=vec4(vec3((col1 * a1)+(col2 * a2)), 0.1);
    
    gl_FragColor.rgb = blend(texture2D(iChannel0, uv));
    
    vec2 uv_m = gl_FragCoord.xy/iResolution.yy;
    float wave_m = sin(uv_m.y*(cos(iGlobalTime*0.9)*16.0)+iGlobalTime)*0.1;
    wave_m *= sin(iGlobalTime*1.4)*1.0;
    uv_m.x += wave_m;
    uv_m.y += iGlobalTime*0.2;
    uv_m *= LOGO_H;
    if ((gl_FragCoord.x+iResolution.y*wave_m) > iResolution.y/LOGO_H && (gl_FragCoord.x+iResolution.y*wave_m) < iResolution.y/LOGO_H*2.0)
        gl_FragColor.rgb = blend(texture2D(iChannel1, uv_m));
    
    float timer = clamp((-5.0)+iGlobalTime/2.0, 0.0, 1.0);
    gl_FragColor.rgb -= timer*texture2D(iChannel2, uv+rand(uv.yy+iGlobalTime)*0.01).rgb;

    gl_FragColor.rgb *= clamp(iGlobalTime, 0.0, 1.0);
    gl_FragColor.rgb *= clamp(17.0-iGlobalTime, 0.0, 1.0);
}
