#define MARCH_PREC 11

uniform float iGlobalTime;
uniform vec2 iResolution;
uniform sampler2D iChannel0;

float rand(vec2 co){
    return fract(sin(dot(co, vec2(12.9898, 78.233))) * 43758.5453);
}

float pallo(vec3 pos, vec3 coord, float r){
    return length(pos - coord) - r;
}

float scene(vec3 pos){
    return min(
        pallo(pos, vec3(0.0, 0.0, (sin(iGlobalTime / 2.0) * 1.5 + 2.0)), 0.8),
        min(
            pallo(pos, vec3((cos(iGlobalTime / 1.1) * 1.8), (sin(iGlobalTime / 1.1) * 1.8), 1.5), 0.3),
            min(
                pallo(pos, vec3((sin(iGlobalTime / 1.4) * 0.6), (cos(iGlobalTime / 1.4) * 1.2), (sin(iGlobalTime / 1.6) * 1.8 + 1.5)), 0.125),
                pallo(pos, vec3((cos(iGlobalTime / 1.4) * 0.6), (sin(iGlobalTime / 1.4) * 1.2), (cos(iGlobalTime / 1.6) * 1.8 + 1.5)), 0.125)
            )
        )
    );
}

float march(vec3 dir, vec3 cam){
    vec3 curPos = cam;
    for(int i=0; i<MARCH_PREC; i++){
        float dist = scene(curPos);
        curPos += dist * dir;
    }
    return length(curPos - cam);
}

void main()
{

    float t = iGlobalTime;
    vec2 uv = (gl_FragCoord.xy / iResolution.yy);
    vec2 uv_t = uv;
    uv -= vec2(0.5, 0.5);
    float cent = ((iResolution.x-iResolution.y)/2.0)/iResolution.y;
    uv.x -= cent;
    vec3 ray = normalize(vec3(uv.x, uv.y, 1.0));
    //ray.x -= rand(uv + iGlobalTime)*0.003;
    //ray.y += rand(uv + iGlobalTime)*0.003;
    vec3 cam = vec3(0.0, 0.0, -3.0);
    float lum = clamp(iGlobalTime/4.0, 0.0, 1.0) / sqrt(march(ray, cam));
    float noise = 0.0;//(rand(uv + iGlobalTime) * 0.034);
    gl_FragColor = vec4((lum * lum + noise), (lum + noise), (lum * 0.8 + noise), 0.2);     //Cyan
//    vec3 rgbCol = vec3(lum + noise); gl_FragColor = vec4(rgbCol, 0.2);                     //B&W

    float fade = iGlobalTime*4.0+1.0;
    uv_t.x -= cent;
    vec4 cColor = texture2D(iChannel0, uv_t);
    if (gl_FragCoord.x > iResolution.y*cent && gl_FragCoord.x < (iResolution.y*cent)+iResolution.y)
        gl_FragColor.rgb = cColor.rgb*(cColor.a/fade) + (gl_FragColor.rgb * (1.0-(cColor.a/fade)));
        
    gl_FragColor.rgb *= mod(gl_FragCoord.y, 2.0);

    gl_FragColor.rgb *= clamp(10.0-iGlobalTime, 0.0, 1.0);
}
