uniform float iGlobalTime;
uniform vec2 iResolution;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;

#define PI 3.14159265

vec2 uv = gl_FragCoord.xy/iResolution.yy;

void main() {
    float ang = iGlobalTime*0.5;
    float h = sin(iGlobalTime*0.3)*12.0;
    vec2 pan = vec2(-iGlobalTime*2.0 , sin(iGlobalTime*0.1)*2.0);

    vec2 uv_w = vec2(uv.x-(iResolution.x/2.0/iResolution.y), uv.y-0.5) * h + pan;
    uv_w = vec2(uv_w.x * sin(ang) - uv_w.y * cos(ang), uv_w.x * cos(ang) + uv_w.y * sin(ang));

    vec4 smp = texture2D(iChannel0, uv_w);
    gl_FragColor = vec4(smp.rgb, 0.1);

    gl_FragColor.rgb *= clamp(sin(uv_w.x*PI)*sin(uv_w.y*PI)*1000.0, 0.0, 1.0);

    vec4 frame = texture2D(iChannel1, gl_FragCoord.xy/iResolution.xy);
    gl_FragColor.rgb = (frame.rgb*frame.a+(gl_FragColor.rgb*(1.0-frame.a)));

    gl_FragColor.rgb *= mod(gl_FragCoord.y, 2.0)-1.0;

    gl_FragColor.rgb *= clamp(iGlobalTime, 0.0, 1.0);
    gl_FragColor.rgb *= clamp(9.0-iGlobalTime, 0.0, 1.0);
}
