uniform float iGlobalTime;
uniform vec2 iResolution;
uniform sampler2D iChannel0;
uniform sampler2D iChannel1;
uniform sampler2D iChannel2;

#define PI  3.14159265
#define PI2 6.28318530

vec2 uv = gl_FragCoord.xy / iResolution.yy;

float rand(vec2 co){
    return fract(sin(dot(co*0.01, vec2(12.9898, 78.233))) * 43758.5453);
}

void text() {
    vec2 uv_t = uv - vec2(iResolution.x/iResolution.y/2.0, 0.5);

    float rt = sin(iGlobalTime)*0.5;
    uv_t = vec2(uv_t.x * cos(rt) - uv_t.y * sin(rt), uv_t.x * sin(rt) + uv_t.y * cos(rt));
    uv_t *= (sin(iGlobalTime)*1.0 + 6.0)*(cos(iGlobalTime*0.5)*0.2+0.7);
    uv_t.y += (sin(uv.x*10.0+iGlobalTime)*0.2+0.2);
    uv_t *= 0.2 + 1.0/(iGlobalTime*0.4);

    vec4 a = texture2D(iChannel0, uv_t);
    vec3 c = vec3(sin(iGlobalTime)*0.2+0.7, sin(iGlobalTime+(PI2/3.0)+uv.y*20.0)*0.2+0.6, sin(iGlobalTime+(PI2/2.0*2.0))*0.2+0.1);

    a.a *= clamp(1000.0 * (sin(uv_t.x*PI) * sin(uv_t.y*PI)), 0.0, 1.0);
    gl_FragColor.rgb = c.rgb * a.a + (gl_FragColor.rgb * (1.0 - a.a));
}

vec3 tunnel() {
    vec2 uv_t = uv - vec2((iResolution.x/iResolution.y)*0.5, 0.5);
    
    float t = 1.0/sqrt(uv_t.x*uv_t.x + uv_t.y*uv_t.y);
    float u = atan(uv_t.y, uv_t.x);
    float v = t+iGlobalTime*6.0;

    u+=sin(v*0.2)*2.87*(sin(v*0.04)*2.0)+(cos(v*0.001)*5.0);   
 
    float l = clamp(sin(u*3.0)*2.0, 0.0, 1.0);
    l/=t*t*1.1;

    vec3 col2 = vec3(0.0, 0.0, 0.0);
    vec3 col1 = vec3(0.0, 0.7, 1.0);

    return ((col1 * l) + (col2 * (1.0-l)));
}

void main() {
    gl_FragColor = vec4(tunnel(), 0.1);
    text();

    gl_FragColor.rgb *= clamp(iGlobalTime, 0.0, 1.0);
    gl_FragColor.rgb *= clamp(7.0-iGlobalTime, 0.0, 1.0);
}
